<?php

namespace app\admin\controller\score;

use app\common\controller\Backend;
use think\Db;
use think\exception\DbException;
use think\exception\PDOException;
use think\exception\ValidateException;
use app\common\model\score\Employee;
use think\response\Json;

/**
 * 队伍管理
 *
 * @icon fa fa-circle-o
 */
class Team extends Backend
{

    /**
     * Team模型对象
     * @var \app\admin\model\score\Team
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\score\Team;

    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     *
     * @return string|Json
     * @throws \think\Exception
     * @throws DbException
     */
    public function index()
    {
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if (false === $this->request->isAjax()) {
            return $this->view->fetch();
        }
        //如果发送的来源是 Selectpage，则转发到 Selectpage
        if ($this->request->request('keyField')) {
            return $this->selectpage();
        }
        list($where, $sort, $order, $offset, $limit, $page, $alias, $bind,$excludearray) = $this->buildparams(null,null,['opertime']);
        //得到查询时间
        $opertime = $excludearray['opertime'] ?? [];
        $start_time = $end_time =null;
        if($opertime){
            //得到查询值
            $value = $opertime['value'];
            list($start_time,$end_time) = explode(" - ",$value);

        }



        $list = $this->model
            ->where($where)
            ->order($sort, $order)
            ->paginate($limit);


        $total = $list->total();
        $list = $list->items();

        foreach ($list as &$row) {
            $row['score_count'] = 0;
            $row['opertime'] = '';
            if($start_time){
                $row['opertime'] = $start_time.'至'.$end_time;
            }
            $row['score_count'] = \app\common\model\score\Team::getPriceByCoachAndTime($row['id'],$start_time,$end_time);

        }
        $result = array("total" => $total, "rows" => $list);
        return json($result);

    }



    /**
     * 添加
     *
     * @return string
     * @throws \think\Exception
     */
    public function add()
    {
        if (false === $this->request->isPost()) {
            return $this->view->fetch();
        }
        $params = $this->request->post('row/a');
        if (empty($params)) {
            $this->error(__('Parameter %s can not be empty', ''));
        }
        $params = $this->preExcludeFields($params);

        if ($this->dataLimit && $this->dataLimitFieldAutoFill) {
            $params[$this->dataLimitField] = $this->auth->id;
        }
        $result = false;
        Db::startTrans();
        try {
            //是否采用模型验证
            if ($this->modelValidate) {
                $name = str_replace("\\model\\", "\\validate\\", get_class($this->model));
                $validate = is_bool($this->modelValidate) ? ($this->modelSceneValidate ? $name . '.add' : $name) : $this->modelValidate;
                $this->model->validateFailException()->validate($validate);
            }
            $score_employee_ids = $params["score_employee_ids"] ??  [];

            $result = $this->model->allowField(true)->save($params);
            //建立新的关联
            Employee::where( "id","in",$score_employee_ids)->update(["team_id"=>$this->model->id]);

            //更新队伍日志记录


            \app\common\model\score\Log::where( "score_employee_id","in",$score_employee_ids )->update(["score_team_id"=>$this->model->id]);


            Db::commit();
        } catch (ValidateException|PDOException|Exception $e) {
            Db::rollback();
            $this->error($e->getMessage());
        }
        if ($result === false) {
            $this->error(__('No rows were inserted'));
        }
        $this->success();
    }

    /**
     * 编辑
     *
     * @param $ids
     * @return string
     * @throws DbException
     * @throws \think\Exception
     */
    public function edit($ids = null)
    {
        $row = $this->model->get($ids);
        if (!$row) {
            $this->error(__('No Results were found'));
        }
        $adminIds = $this->getDataLimitAdminIds();
        if (is_array($adminIds) && !in_array($row[$this->dataLimitField], $adminIds)) {
            $this->error(__('You have no permission'));
        }
        if (false === $this->request->isPost()) {
            $this->view->assign('row', $row);
            return $this->view->fetch();
        }
        $params = $this->request->post('row/a');
        if (empty($params)) {
            $this->error(__('Parameter %s can not be empty', ''));
        }
        $params = $this->preExcludeFields($params);
        $result = false;
        Db::startTrans();
        try {
            //是否采用模型验证
            if ($this->modelValidate) {
                $name = str_replace("\\model\\", "\\validate\\", get_class($this->model));
                $validate = is_bool($this->modelValidate) ? ($this->modelSceneValidate ? $name . '.edit' : $name) : $this->modelValidate;
                $row->validateFailException()->validate($validate);
            }


            $score_employee_ids = $params["score_employee_ids"] ??  [];
            $result = $row->allowField(true)->save($params);


            //清除旧的关联
            Employee::where( "team_id",$row->id)->update(["team_id"=>0]);
            //建立新的关联
            Employee::where( "id","in",$score_employee_ids)->update(["team_id"=>$row->id]);

            //更新队伍日志记录
            //清除旧的关联
            \app\common\model\score\Log::where( "score_team_id",$row->id )->update(["score_team_id"=>0]);

            \app\common\model\score\Log::where( "score_employee_id","in",$score_employee_ids )->update(["score_team_id"=>$row->id]);


            Db::commit();
        } catch (ValidateException|PDOException|Exception $e) {
            Db::rollback();
            $this->error($e->getMessage());
        }
        if (false === $result) {
            $this->error(__('No rows were updated'));
        }
        $this->success();
    }

}
